Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/PVtheta.F
===================================================================
--- LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/PVtheta.F	(revision 844)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/PVtheta.F	(revision 844)
@@ -0,0 +1,196 @@
+      SUBROUTINE PVtheta(ilon,ilev,pucov,pvcov,pteta,
+     $           ztfi,zplay,zplev,
+     $           nbteta,theta,PVteta)
+      IMPLICIT none
+
+c=======================================================================
+c
+c   Auteur:  I. Musat
+c   -------
+c
+c   Objet:
+c   ------
+c
+c    *******************************************************************
+c    Calcul de la vorticite potentielle PVteta sur des iso-theta selon
+c    la methodologie du NCEP/NCAR :
+c    1) on calcule la stabilite statique N**2=g/T*(dT/dz+g/cp) sur les
+c       niveaux du modele => N2
+c    2) on interpole les vents, la temperature et le N**2 sur des isentropes
+c       (en fait sur des iso-theta) lineairement en log(theta) =>
+c       ucovteta, vcovteta, N2teta
+c    3) on calcule la vorticite absolue sur des iso-theta => vorateta
+c    4) on calcule la densite rho sur des iso-theta => rhoteta 
+c
+c       rhoteta = (T/theta)**(cp/R)*p0/(R*T)
+c
+c    5) on calcule la vorticite potentielle sur des iso-theta => PVteta
+c
+c       PVteta = (vorateta * N2 * theta)/(g * rhoteta) ! en PVU
+c
+c       NB: 1PVU=10**(-6) K*m**2/(s * kg)
+c
+c       PVteta =  vorateta * N2/(g**2 * rhoteta) ! en 1/(Pa*s)
+c
+c
+c    *******************************************************************
+c
+c
+c     Variables d'entree : ilon,ilev,pucov,pvcov,pteta,ztfi,zplay,zplev,nbteta,theta
+c                       -> sur la grille dynamique
+c     Variable de sortie : PVteta
+c                       -> sur la grille physique 
+c=======================================================================
+
+#include "dimensions.h"
+#include "paramet.h"
+c
+c variables Input
+c
+      INTEGER ilon, ilev
+      REAL pvcov(iip1,jjm,ilev)
+      REAL pucov(iip1,jjp1,ilev)
+      REAL pteta(iip1,jjp1,ilev)
+      REAL ztfi(ilon,ilev)
+      REAL zplay(ilon,ilev), zplev(ilon,ilev+1)
+      INTEGER nbteta
+      REAL theta(nbteta)
+c
+c variable Output
+c
+      REAL PVteta(ilon,nbteta)
+c
+c variables locales
+c
+      INTEGER i, j, l, ig0
+      REAL SSUM
+      REAL teta(ilon, ilev)
+      REAL ptetau(ip1jmp1, ilev), ptetav(ip1jm, ilev)
+      REAL ucovteta(ip1jmp1,ilev), vcovteta(ip1jm,ilev)
+      REAL N2(ilon,ilev-1), N2teta(ilon,nbteta)
+      REAL ztfiteta(ilon,nbteta)
+      REAL rhoteta(ilon,nbteta)
+      REAL vorateta(iip1,jjm,nbteta)
+      REAL voratetafi(ilon,nbteta), vorpol(iim)
+c
+#include "comgeom2.h"
+#include "comconst.h"
+#include "comvert.h"
+c
+c projection teta sur la grille physique
+c
+      DO l=1,llm
+       teta(1,l)   =  pteta(1,1,l)
+       ig0         = 2
+       DO j = 2, jjm
+        DO i = 1, iim
+         teta(ig0,l)    = pteta(i,j,l)
+         ig0            = ig0 + 1
+        ENDDO
+       ENDDO
+       teta(ig0,l)    = pteta(1,jjp1,l)
+      ENDDO
+c
+c calcul pteta sur les grilles U et V
+c
+      DO l=1, llm
+       DO j=1, jjp1
+        DO i=1, iip1
+         ig0=i+(j-1)*iip1
+         ptetau(ig0,l)=pteta(i,j,l)
+        ENDDO !i
+       ENDDO !j
+       DO j=1, jjm
+        DO i=1, iip1
+         ig0=i+(j-1)*iip1
+         ptetav(ig0,l)=0.5*(pteta(i,j,l)+pteta(i,j+1,l))
+        ENDDO !i
+       ENDDO !j
+      ENDDO !l
+c
+c projection pucov, pvcov sur une surface de theta constante
+c
+      DO l=1, nbteta
+cIM 1rout CALL tetaleveli1j1(ip1jmp1,llm,.true.,ptetau,theta(l),
+       CALL tetalevel(ip1jmp1,llm,.true.,ptetau,theta(l),
+     .                pucov,ucovteta(:,l))
+cIM 1rout CALL tetaleveli1j(ip1jm,llm,.true.,ptetav,theta(l),
+       CALL tetalevel(ip1jm,llm,.true.,ptetav,theta(l),
+     .                pvcov,vcovteta(:,l))
+      ENDDO !l
+c
+c calcul vorticite absolue sur une iso-theta : vorateta
+c
+      CALL tourabs(nbteta,vcovteta,ucovteta,vorateta)
+c
+c projection vorateta sur la grille physique => voratetafi
+c
+      DO l=1,nbteta
+       DO j=2,jjm
+        ig0=1+(j-2)*iim
+        DO i=1,iim
+         voratetafi(ig0+i+1,l) = vorateta( i ,j-1,l) * alpha4(i+1,j) +
+     $                           vorateta(i+1,j-1,l) * alpha1(i+1,j) +
+     $                           vorateta(i  ,j  ,l) * alpha3(i+1,j) +
+     $                           vorateta(i+1,j  ,l) * alpha2(i+1,j)
+        ENDDO
+        voratetafi(ig0 +1,l) = voratetafi(ig0 +1+ iim,l)
+       ENDDO
+      ENDDO
+c
+      DO l=1,nbteta
+       DO i=1,iim
+        vorpol(i)  = vorateta(i,1,l)*aire(i,1)
+       ENDDO
+       voratetafi(1,l)= SSUM(iim,vorpol,1)/apoln
+      ENDDO
+c
+      DO l=1,nbteta
+       DO i=1,iim
+        vorpol(i)  = vorateta(i,jjm,l)* aire(i,jjm +1)
+       ENDDO
+       voratetafi(ilon,l)= SSUM(iim,vorpol,1)/apols
+      ENDDO
+c 
+c calcul N**2 sur la grille physique => N2
+c
+      DO l=1, llm-1 
+       DO i=1, ilon
+        N2(i,l) = (g**2 * zplay(i,l) * 
+     $            (ztfi(i,l+1)-ztfi(i,l)) )/
+     $            (R*ztfi(i,l)*ztfi(i,l)*
+     $            (zplev(i,l)-zplev(i,l+1)) )+
+     $            (g**2)/(ztfi(i,l)*CPP)
+       ENDDO !i
+      ENDDO !l
+c
+c calcul N2 sur une iso-theta => N2teta 
+c
+      DO l=1, nbteta
+       CALL tetalevel(ilon,llm-1,.true.,teta,theta(l),
+     $                N2,N2teta(:,l))
+       CALL tetalevel(ilon,llm,.true.,teta,theta(l),
+     $                ztfi,ztfiteta(:,l))
+      ENDDO !l=1, nbteta
+c
+c calcul rho et PV sur une iso-theta : rhoteta, PVteta
+c
+      DO l=1, nbteta
+       DO i=1, ilon
+        rhoteta(i,l)=(ztfiteta(i,l)/theta(l))**(CPP/R)*
+     $  (preff/(R*ztfiteta(i,l)))
+c
+c PVteta en PVU
+c
+        PVteta(i,l)=(theta(l)*g*voratetafi(i,l)*N2teta(i,l))/
+     $              (g**2*rhoteta(i,l))
+c
+c PVteta en 1/(Pa*s)
+c
+        PVteta(i,l)=(voratetafi(i,l)*N2teta(i,l))/
+     $              (g**2*rhoteta(i,l))
+       ENDDO !i
+      ENDDO !l
+c
+      RETURN
+      END 
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/advtrac.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/advtrac.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/advtrac.F	(revision 844)
@@ -4,11 +4,9 @@
 c
 c
-#ifdef INCA_CH4
+#ifdef INCA
       SUBROUTINE advtrac(pbaru,pbarv ,
      *                   p,  masse,q,iapptrac,teta,
      *                  flxw,
-     *                  pk,
-     *                  mmt_adj,
-     *                  hadv_flg)
+     *                  pk)
 #else
       SUBROUTINE advtrac(pbaru,pbarv ,
@@ -16,5 +14,4 @@
      *                  pk)
 #endif
-
 c     Auteur :  F. Hourdin
 c
@@ -51,7 +48,5 @@
       REAL p( ip1jmp1,llmp1 ),teta(ip1jmp1,llm)
       REAL pk(ip1jmp1,llm)
-#ifdef INCA_CH4
-      INTEGER            :: hadv_flg(nq)
-      REAL               :: mmt_adj(ip1jmp1,llm)
+#ifdef INCA
       REAL               :: flxw(ip1jmp1,llm)
 #endif
@@ -129,5 +124,5 @@
         CALL groupe( massem, pbaruc,pbarvc, pbarug,pbarvg,wg )
 
-#ifdef INCA_CH4
+#ifdef INCA
       ! ... Flux de masse diaganostiques traceurs
       flxw = wg / FLOAT(iapp_tracvl)
@@ -214,7 +209,8 @@
         else if (iadv(iq).eq.20) then
             call pentes_ini (q(1,1,iq),wg,massem,pbarug,pbarvg,0)
-#ifdef INCA_CH4
+#ifdef INCA
        do iiq = iq+1, iq+3
-         q(:,:,iiq)=q(:,:,iiq)*mmt_adj(:,:,1)
+c         q(:,:,iiq)=q(:,:,iiq)*mmt_adj(:,:,1)
+          q(:,:,iiq)=q(:,:,iiq)*1
        enddo
 #endif
@@ -232,7 +228,8 @@
            call  prather(q(1,1,iq),wg,massem,pbarug,pbarvg,
      s                     n,dtbon)
-#ifdef INCA_CH4
+#ifdef INCA
        do iiq = iq+1, iq+9
-         q(:,:,iiq)=q(:,:,iiq)*mmt_adj(:,:,1)
+c         q(:,:,iiq)=q(:,:,iiq)*mmt_adj(:,:,1)
+         q(:,:,iiq)=q(:,:,iiq)*1
        enddo
 #endif
@@ -338,6 +335,6 @@
 
 c                  call clock(t_final)
-                  tps_cpu=t_final-t_initial
-                  cpuadv(iq)=cpuadv(iq)+tps_cpu
+cym                  tps_cpu=t_final-t_initial
+cym                  cpuadv(iq)=cpuadv(iq)+tps_cpu
 
        end DO
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/advtrac.h
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/advtrac.h	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/advtrac.h	(revision 844)
@@ -5,5 +5,7 @@
 c INCLUDE 'advtrac.h'
 
-      COMMON/advtr/iadv,hadv,vadv,tnom,tname,ttext,niadv
+      COMMON/advtr/iadv,hadv,vadv,tnom,tname,ttext,niadv,
+     &     nbtrac, nprath, mmt_adj, hadv_flg, vadv_flg, conv_flg, 
+     &     pbl_flg, tracnam
       INTEGER iadv(nqmx) ! indice schema de transport 
       INTEGER hadv(nqmx) ! indice schema transport horizontal 
@@ -13,3 +15,13 @@
       character*10 tname(nqmx) ! nom du traceur pour restart
       character*13 ttext(nqmx) ! nom long du traceur pour sorties
+
+
+      integer nbtrac
+      integer nprath
+      real    mmt_adj(iim+1,jjm+1,llm, 1) 
+      integer hadv_flg(nqmx)
+      integer vadv_flg(nqmx)
+      integer conv_flg(nqmx-2) 
+      integer pbl_flg(nqmx-2)
+      character*8 tracnam(nqmx-2) 
 c-----------------------------------------------------------------------
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/advx.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/advx.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/advx.F	(revision 844)
@@ -106,5 +106,6 @@
          DO j = 1,jjp1
             DO i = 1,iim
-               sqi = sqi + S0(i,j,l,9)
+cIM 240305            sqi = sqi + S0(i,j,l,9)
+               sqi = sqi + S0(i,j,l,ntra)
             ENDDO
          ENDDO
@@ -483,5 +484,6 @@
         DO j = 1, jjp1
           DO i = 1, iim
-             sqf = sqf + S0(i,j,l,9)
+cIM 240405          sqf = sqf + S0(i,j,l,9)
+             sqf = sqf + S0(i,j,l,ntra)
           END DO  
         END DO
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/advz.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/advz.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/advz.F	(revision 844)
@@ -105,5 +105,6 @@
          DO j = 1,jjp1
             DO i = 1,iim
-               sqi = sqi + S0(i,j,l,9)
+cIM 240305            sqi = sqi + S0(i,j,l,9)
+               sqi = sqi + S0(i,j,l,ntra)
             ENDDO
          ENDDO
@@ -307,5 +308,6 @@
          DO j = 1,jjp1
             DO i = 1,iim
-               sqf = sqf + S0(i,j,l,9)
+cIM 240305            sqf = sqf + S0(i,j,l,9)
+               sqf = sqf + S0(i,j,l,ntra)
             ENDDO
          ENDDO
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/bilan_dyn.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/bilan_dyn.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/bilan_dyn.F	(revision 844)
@@ -2,7 +2,4 @@
 ! $Header$
 !
-c
-c $Header$
-c
       SUBROUTINE bilan_dyn (ntrac,dt_app,dt_cum,
      s  ps,masse,pk,flux_u,flux_v,teta,phi,ucov,vcov,trac)
@@ -63,6 +60,9 @@
 
 
-      character*6 nom(nQ)
-      character*6 unites(nQ)
+cym      character*6 nom(nQ)
+cym      character*6 unites(nQ)
+      character*6,save :: nom(nQ)
+      character*6,save :: unites(nQ)
+
       character*10 file
       integer ifile
@@ -116,7 +116,11 @@
       parameter (ntr=5)
 
-      character*10 znom(ntr,nQ)
-      character*20 znoml(ntr,nQ)
-      character*10 zunites(ntr,nQ)
+cym      character*10 znom(ntr,nQ)
+cym      character*20 znoml(ntr,nQ)
+cym      character*10 zunites(ntr,nQ)
+      character*10,save :: znom(ntr,nQ)
+      character*20,save :: znoml(ntr,nQ)
+      character*10,save :: zunites(ntr,nQ)
+
       integer iave,itot,immc,itrs,istn
       data iave,itot,immc,itrs,istn/1,2,3,4,5/
@@ -163,4 +167,6 @@
       time=time+dt_app
       itau=itau+1
+cIM
+      ndex3d=0
 
       if (first) then
@@ -301,4 +307,5 @@
 
 c   énergie cinétique
+      ucont(:,:,:)=0
       CALL covcont(llm,ucov,vcov,ucont,vcont)
       CALL enercin(vcov,ucov,vcont,ucont,ecin)
@@ -315,5 +322,5 @@
       Q(:,:,:,iang)=ang(:,:,:)
       Q(:,:,:,iu)=unat(:,:,:)
-      Q(:,:,:,iovap)=q(:,:,:,1)
+      Q(:,:,:,iovap)=trac(:,:,:,1)
       Q(:,:,:,iun)=1.
 
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/caladvtrac.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/caladvtrac.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/caladvtrac.F	(revision 844)
@@ -4,11 +4,9 @@
 c
 c
-#ifdef INCA_CH4
+#ifdef INCA
             SUBROUTINE caladvtrac(q,pbaru,pbarv ,
      *                   p ,masse, dq ,  teta,
      *                   flxw,
-     *                   pk,
-     *                   mmt_adj,
-     *                   hadv_flg)
+     *                   pk)
 #else
             SUBROUTINE caladvtrac(q,pbaru,pbarv ,
@@ -41,7 +39,5 @@
       REAL p( ip1jmp1,llmp1),q( ip1jmp1,llm,nqmx),dq( ip1jmp1,llm,2 )
       REAL teta( ip1jmp1,llm),pk( ip1jmp1,llm)
-#ifdef INCA_CH4
-      INTEGER            :: hadv_flg(nq)
-      REAL               :: mmt_adj(iip1,jjp1,llm)
+#ifdef INCA
       REAL               :: flxw(ip1jmp1,llm)
 #endif
@@ -73,11 +69,9 @@
 c   advection
 
-#ifdef INCA_CH4
+#ifdef INCA
       CALL advtrac( pbaru,pbarv, 
      *             p,  masse,q,iapptrac, teta,
      .             flxw,
-     .             pk,
-     .             mmt_adj,
-     .             hadv_flg)
+     .             pk)
 #else
       CALL advtrac( pbaru,pbarv, 
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/calfis.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/calfis.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/calfis.F	(revision 844)
@@ -23,5 +23,5 @@
      $                  pdq,
      $                  pw,
-#ifdef INCA_CH4
+#ifdef INCA
      $                  flxw,
 #endif
@@ -162,6 +162,13 @@
       REAL zsinbis(iim),zcosbis(iim),z1bis(iim)
       REAL unskap, pksurcp
-
-#ifdef INCA_CH4
+c
+cIM diagnostique PVteta, Amip2
+      INTEGER ntetaSTD
+      PARAMETER(ntetaSTD=3)
+      REAL rtetaSTD(ntetaSTD)
+      DATA rtetaSTD/350., 380., 405./
+      REAL PVteta(ngridmx,ntetaSTD)
+c
+#ifdef INCA
       REAL flxw(iip1,jjp1,llm)
       REAL flxwfi(ngridmx,llm)
@@ -430,7 +437,11 @@
 
       ENDDO
-
-
-#ifdef INCA_CH4
+c
+cIM calcul PV a teta=350, 380, 405K
+      CALL PVtheta(ngridmx,llm,pucov,pvcov,pteta,
+     $           ztfi,zplay,zplev,
+     $           ntetaSTD,rtetaSTD,PVteta)
+c
+#ifdef INCA
       CALL gr_dyn_fi(llm,iip1,jjp1,ngridmx,flxw,flxwfi)
 #endif
@@ -461,5 +472,5 @@
      .             zqfi,
      .             pvervel,
-#ifdef INCA_CH4
+#ifdef INCA
      .             flxwfi,
 #endif
@@ -468,5 +479,8 @@
      .             zdtfi,
      .             zdqfi,
-     .             zdpsrf)
+     .             zdpsrf,
+cIM diagnostique PVteta, Amip2          
+     .             pducov,
+     .             PVteta)
 
 500   CONTINUE
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/conf_dat2d.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/conf_dat2d.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/conf_dat2d.F	(revision 844)
@@ -215,4 +215,7 @@
        ENDDO
 
+      deallocate(xtemp)
+      deallocate(ytemp)
+
       RETURN
       END
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/conf_gcm.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/conf_gcm.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/conf_gcm.F	(revision 844)
@@ -149,7 +149,7 @@
 !Config  Key  = iapp_tracvl
 !Config  Desc = frequence du groupement des flux 
-!Config  Def  = 5
+!Config  Def  = iperiod
 !Config  Help = frequence du groupement des flux (en pas de temps) 
-       iapp_tracvl = 5
+       iapp_tracvl = iperiod
        CALL getin('iapp_tracvl',iapp_tracvl)
 
@@ -365,4 +365,16 @@
        iflag_con = 2
        CALL getin('iflag_con',iflag_con)
+!
+!Config  Key  = ip_ebil_dyn
+!Config  Desc = PRINT level for energy conserv. diag.
+!Config  Def  = 0
+!Config  Help = PRINT level for energy conservation diag. ;
+!               les options suivantes existent :
+!Config         0 pas de print
+!Config         1 pas de print
+!Config         2 print,
+       ip_ebil_dyn = 0
+       CALL getin('ip_ebil_dyn',ip_ebil_dyn)
+!
 
       DO i = 1, longcles
@@ -574,4 +586,12 @@
       ENDIF
 c
+!Config  Key  = offline
+!Config  Desc = Nouvelle eau liquide
+!Config  Def  = n
+!Config  Help = Permet de mettre en route la
+!Config         nouvelle parametrisation de l'eau liquide !
+       offline = .FALSE.
+       CALL getin('offline',offline)
+
 
       write(lunout,*)' #########################################'
@@ -615,4 +635,5 @@
       write(lunout,*)' tauxx = ', tauxx
       write(lunout,*)' tauyy = ', tauyy
+      write(lunout,*)' offline = ', offline
 
       RETURN
@@ -720,4 +741,13 @@
        CALL getin('ysinus',ysinus)
 c
+!Config  Key  = offline
+!Config  Desc = Nouvelle eau liquide
+!Config  Def  = n
+!Config  Help = Permet de mettre en route la
+!Config         nouvelle parametrisation de l'eau liquide !
+       offline = .FALSE.
+       CALL getin('offline',offline)
+      write(lunout,*)' offline = ', offline
+
 
       write(lunout,*)' #########################################'
@@ -761,4 +791,5 @@
       write(lunout,*)' taux = ', taux
       write(lunout,*)' tauy = ', tauy
+      write(lunout,*)' offline = ', offline
 c
       RETURN
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/control.h
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/control.h	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/control.h	(revision 844)
@@ -2,15 +2,23 @@
 ! $Header$
 !
-c-----------------------------------------------------------------------
-c INCLUDE 'control.h'
+!
+!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
+!                 veillez à n'utiliser que des ! pour les commentaires
+!                 et à bien positionner les & des lignes de continuation 
+!                 (les placer en colonne 6 et en colonne 73)
+!
+!-----------------------------------------------------------------------
+! INCLUDE 'control.h'
 
-      COMMON/control/nday,day_step,
-     $              iperiod,iapp_tracvl,iconser,iecri,idissip,iphysiq ,
-     $              periodav,ecritphy,iecrimoy,dayref,anneeref,
-     $              raz_date
+      COMMON/control/nday,day_step,                                     &
+     &              iperiod,iapp_tracvl,iconser,iecri,idissip,iphysiq , &
+     &              periodav,ecritphy,iecrimoy,dayref,anneeref,         &
+     &              raz_date,offline,ip_ebil_dyn
 
-      INTEGER   nday,day_step,iperiod,iapp_tracvl,iconser,iecri,
-     $          idissip,iphysiq,iecrimoy,dayref,anneeref, raz_date
+      INTEGER   nday,day_step,iperiod,iapp_tracvl,iconser,iecri,        &
+     &          idissip,iphysiq,iecrimoy,dayref,anneeref, raz_date      &
+     &          ,ip_ebil_dyn
       REAL periodav, ecritphy
+      logical offline
 
-c-----------------------------------------------------------------------
+!-----------------------------------------------------------------------
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/create_etat0_limit.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/create_etat0_limit.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/create_etat0_limit.F	(revision 844)
@@ -3,4 +3,7 @@
 !
        PROGRAM create_etat0_limit
+       USE dimphy
+       USE comgeomphy
+
 c
 c
@@ -18,5 +21,5 @@
 c
 c     on cree le masque dans etat0 que l'on passe ensuite dans limit pour 
-c     garder les cohérences
+c     garder les coherences
 
       LOGICAL interbar, extrap , oldice
@@ -25,7 +28,10 @@
 #include "paramet.h"
 #include "indicesol.h"
-#include "dimphy.h"
+cym#include "dimphy.h" 
       REAL :: masque(iip1,jjp1)
-      REAL :: pctsrf(klon, nbsrf)
+      REAL :: pctsrf(iim*(jjm-1)+2, nbsrf)
+
+      CALL Init_Phys_lmdz(iim,jjp1,llm,nqmx-2,1,(jjm-1)*iim+2)
+      call InitComgeomphy
 
       WRITE(6,*) '  *********************  '
@@ -38,5 +44,6 @@
       WRITE(6,*) '  *********************  '
       WRITE(6,1)
-c
+      
+c     
       CALL  limit_netcdf ( interbar, extrap , oldice, masque, pctsrf )
 
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/dynetat0.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/dynetat0.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/dynetat0.F	(revision 844)
@@ -106,8 +106,8 @@
       IF ( tab_cntrl(24).EQ.1. )  THEN
         fxyhypb  = . TRUE .
-        dzoomx   = tab_cntrl(25)
-        dzoomy   = tab_cntrl(26)
-        taux     = tab_cntrl(28)
-        tauy     = tab_cntrl(29)
+c        dzoomx   = tab_cntrl(25)
+c        dzoomy   = tab_cntrl(26)
+c        taux     = tab_cntrl(28)
+c        tauy     = tab_cntrl(29)
       ELSE
         fxyhypb = . FALSE .
Index: LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/dynredem.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/dyn3d/dynredem.F	(revision 525)
+++ LMDZ4/branches/LMDZ4_V3_patches/libf/dyn3d/dynredem.F	(revision 844)
@@ -144,5 +144,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"controle",NF_DOUBLE,1,idim_index,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"controle",NF_FLOAT,1,idim_index,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 22,
      .                       "Parametres de controle")
@@ -155,5 +161,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"rlonu",NF_DOUBLE,1,idim_rlonu,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"rlonu",NF_FLOAT,1,idim_rlonu,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 23,
      .                       "Longitudes des points U")
@@ -166,5 +178,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"rlatu",NF_DOUBLE,1,idim_rlatu,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"rlatu",NF_FLOAT,1,idim_rlatu,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 22,
      .                       "Latitudes des points U")
@@ -177,5 +195,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"rlonv",NF_DOUBLE,1,idim_rlonv,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"rlonv",NF_FLOAT,1,idim_rlonv,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 23,
      .                       "Longitudes des points V")
@@ -188,5 +212,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"rlatv",NF_DOUBLE,1,idim_rlatv,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"rlatv",NF_FLOAT,1,idim_rlatv,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 22,
      .                       "Latitudes des points V")
@@ -199,5 +229,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"nivsigs",NF_DOUBLE,1,idim_s,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"nivsigs",NF_FLOAT,1,idim_s,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 28,
      .                       "Numero naturel des couches s")
@@ -210,5 +246,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"nivsig",NF_DOUBLE,1,idim_sig,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"nivsig",NF_FLOAT,1,idim_sig,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 32,
      .                       "Numero naturel des couches sigma")
@@ -221,5 +263,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"ap",NF_DOUBLE,1,idim_sig,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"ap",NF_FLOAT,1,idim_sig,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 26,
      .                       "Coefficient A pour hybride")
@@ -232,5 +280,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"bp",NF_DOUBLE,1,idim_sig,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"bp",NF_FLOAT,1,idim_sig,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 26,
      .                       "Coefficient B pour hybride")
@@ -243,5 +297,11 @@
 c
       ierr = NF_REDEF (nid)
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"presnivs",NF_DOUBLE,1,idim_s,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"presnivs",NF_FLOAT,1,idim_s,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
@@ -256,5 +316,11 @@
       dims2(1) = idim_rlonu
       dims2(2) = idim_rlatu
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"cu",NF_DOUBLE,2,dims2,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"cu",NF_FLOAT,2,dims2,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 29,
      .                       "Coefficient de passage pour U")
@@ -269,5 +335,11 @@
       dims2(1) = idim_rlonv
       dims2(2) = idim_rlatv
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"cv",NF_DOUBLE,2,dims2,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"cv",NF_FLOAT,2,dims2,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 29,
      .                       "Coefficient de passage pour V")
@@ -284,5 +356,11 @@
       dims2(1) = idim_rlonv
       dims2(2) = idim_rlatu
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"aire",NF_DOUBLE,2,dims2,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"aire",NF_FLOAT,2,dims2,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 22,
      .                       "Aires de chaque maille")
@@ -299,5 +377,11 @@
       dims2(1) = idim_rlonv
       dims2(2) = idim_rlatu
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"phisinit",NF_DOUBLE,2,dims2,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"phisinit",NF_FLOAT,2,dims2,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 19,
      .                       "Geopotentiel au sol")
@@ -313,5 +397,11 @@
       ierr = NF_REDEF (nid) ! entrer dans le mode de definition
 c
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"temps",NF_DOUBLE,1,idim_tim,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"temps",NF_FLOAT,1,idim_tim,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 19,
      .                       "Temps de simulation")
@@ -326,5 +416,11 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"ucov",NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"ucov",NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 9,
      .                       "Vitesse U")
@@ -334,5 +430,11 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"vcov",NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"vcov",NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 9,
      .                       "Vitesse V")
@@ -342,5 +444,11 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"teta",NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"teta",NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 11,
      .                       "Temperature")
@@ -352,5 +460,11 @@
       IF(nq.GE.1) THEN
       DO iq=1,nq
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,tname(iq),NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,tname(iq),NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 12,ttext(iq))
       ENDDO
@@ -361,5 +475,11 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"masse",NF_DOUBLE,4,dims4,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"masse",NF_FLOAT,4,dims4,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 12,
      .                       "C est quoi ?")
@@ -368,5 +488,11 @@
       dims3(2) = idim_rlatu
       dims3(3) = idim_tim
+cIM 220306 BEG
+#ifdef NC_DOUBLE
+      ierr = NF_DEF_VAR (nid,"ps",NF_DOUBLE,3,dims3,nvarid)
+#else
       ierr = NF_DEF_VAR (nid,"ps",NF_FLOAT,3,dims3,nvarid)
+#endif
+cIM 220306 END
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 15,
      .                       "Pression au sol")
@@ -394,4 +520,5 @@
 #include "comgeom.h"
 #include "advtrac.h"
+#include "temps.h"
 
       INTEGER nq, l
@@ -406,4 +533,7 @@
       INTEGER ierr
       INTEGER iq
+      INTEGER length
+      PARAMETER (length = 100)
+      REAL tab_cntrl(length) ! tableau des parametres du run
       character*20 modname
       character*80 abort_message
@@ -435,4 +565,25 @@
 #endif
       PRINT*, "Enregistrement pour ", nb, time
+
+c
+c  Re-ecriture du tableau de controle, itaufin n'est plus defini quand
+c  on passe dans dynredem0
+      ierr = NF_INQ_VARID (nid, "controle", nvarid)
+      IF (ierr .NE. NF_NOERR) THEN
+         abort_message="dynredem1: Le champ <controle> est absent"
+         ierr = 1
+         CALL abort_gcm(modname,abort_message,ierr)
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tab_cntrl)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, tab_cntrl)
+#endif
+       tab_cntrl(31) = FLOAT(itau_dyn + itaufin)
+#ifdef NC_DOUBLE
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tab_cntrl)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,tab_cntrl)
+#endif
 
 c  Ecriture des champs
